<h4 style="font-family:'Garamond',sans-serif;margin:9px 9px 9px 9px;">Run</h4>
<div class="row" style="margin:0px;padding:0px;">
    <div class="column" style="width:48%;">
        <div class="row">
            @await Html.PartialAsync("_Grid",1)  
        </div>
        <div class="row">
            <button type="button" id="btnStart" class="btn btn-info" style="float:left;">Start</button>
            <button type="button" id="btnPause" class="btn btn-info" style="float:left;">Pause</button>
            <button type="button" id="btnStop" class="btn btn-info" style="float:left;">Stop</button>    
        </div>
        
    </div>
    <div class="column" style="width:48%;">
        <ul class="nav nav-tabs" id="testTab">
            <li class="nav-item">
                <a href="#tab_1" class="nav-link active" data-bs-toggle="tab">Samples</a>
            </li>
            <li class="nav-item">
                <a href="#tab_2" class="nav-link" data-bs-toggle="tab">Reagents</a>
            </li>
            <li class="nav-item">
                <a href="#tab_3" class="nav-link" data-bs-toggle="tab">Cuvettes</a>
            </li>
        </ul>
        <div class="tab-content">
            <div class="tab-pane fade" id="tab_1">
                <div>
                </div>
            </div>
            <div class="tab-pane fade" id="tab_2">
                <div>
                </div>
            </div>
            <div class="tab-pane fade" id="tab_3">
                <div>
                </div>
            </div>
        </div>
    </div>
</div>

<script type="text/javascript">

var circleList = [];
var rectangleList = [];
var canvasElement=document.getElementById('canvas');
var ctx = canvasElement.getContext('2d');   
CanvasRenderingContext2D.prototype.fillPolygon = function (pointsArray, fillColor,strokeColor,text) {
    if (pointsArray.length <= 0) return;
    
    const rectangle = new Path2D();
    rectangle.moveTo(pointsArray[0][0], pointsArray[0][1]);     
    for (var i = 0; i < pointsArray.length; i++) {
        rectangle.lineTo(pointsArray[i][0], pointsArray[i][1]);
    }
    if (strokeColor != null && strokeColor != undefined)
        this.strokeStyle = strokeColor;

    if (fillColor != null && fillColor != undefined) {
        this.fillStyle = fillColor;
        this.fill();
    }
    this.fill(rectangle);
    this.stroke(rectangle);
    rectangleList.push(rectangle);
    this.fillStyle = 'rgb(0,0,0)';
    this.strokeStyle = 'rgb(0,0,0)';
    this.font="10px Arial";
    var MinX = Math.min(pointsArray[0][0], pointsArray[2][0],pointsArray[1][0], pointsArray[3][0]);
    var MinY = Math.min(pointsArray[0][1], pointsArray[2][1],pointsArray[1][1], pointsArray[3][1]);

    var MaxX = Math.max(pointsArray[0][0], pointsArray[2][0],pointsArray[1][0], pointsArray[3][0]);
    var MaxY = Math.max(pointsArray[0][1], pointsArray[2][1],pointsArray[1][1], pointsArray[3][1]);

    var xPos= MinX + ((MaxX - MinX) / 2) - 6.5;
    var yPos= MinY + ((MaxY - MinY) / 2) - 7;
    //this.fillText(text,xPos,yPos);
}

canvasElement.addEventListener('click', function(event) {
        event = event || window.event;
        for (var i = rectangleList.length - 1; i >= 0; i--){  
            if (rectangleList[i] && ctx.isPointInPath(rectangleList[i], event.offsetX, event.offsetY)) {
            canvasElement.style.cursor = 'pointer';
                ctx.lineWidth = 2;
                ctx.fillStyle = 'orange';
                ctx.fill(rectangleList[i]);
            return
            } else {
                canvasElement.style.cursor = 'default';
                    ctx.fillStyle = 'rgb(130, 130, 130)';
                    ctx.lineWidth = 2;
                    for (var d = rectangleList.length - 1; d >= 0; d--){ 
                    ctx.fill(rectangleList[d]);
                    }
                }
            }
         for (var i = circleList.length - 1; i >= 0; i--){  
            if (circleList[i] && ctx.isPointInPath(circleList[i], event.offsetX, event.offsetY)) {
            canvasElement.style.cursor = 'pointer';
                ctx.lineWidth = 2;
                ctx.fillStyle = 'orange';
                ctx.fill(circleList[i]);
            return
            } else {
                canvasElement.style.cursor = 'default';
                    ctx.fillStyle = 'red';
                    ctx.lineWidth = 2;
                    for (var d = circleList.length - 1; d >= 0; d--){ 
                    ctx.fill(circleList[d]);
                    }
                }
            }      
    });

CanvasRenderingContext2D.prototype.fillCircle = function(point,radius, fillColor,strokeColor,text) {
    if (point.length <= 0) return;
    this.lineWidth = 2;
    this.strokeStyle = strokeColor;
    this.moveTo(point[0], point[1]);
    const circle = new Path2D();
    circle.arc(point[0],point[1],radius, 0, 2 * Math.PI);
    this.fillStyle = 'red';
    
    this.fill(circle);
    this.stroke(circle);

    circleList.push(circle);
    this.fillStyle = 'rgb(0,0,0)';
    this.strokeStyle = 'rgb(0,0,0)';
    this.font="20px Arial";
    this.fillText(text,point[0],point[1]);    
}

DrawFullRack();

function DrawFullRack()
{
    var drg, drg1, m_Scale = 0.7;
    var m_Cxp;
    var m_x0, m_y0;
    var x, y, xb, yb;
    var i = 0;
    var bt = 0;
    var CuvetCount=70,ReagentCount=40,SampleCount=40;
    var Rec_Point=Array(CuvetCount+1);
   /* var Reg_Point=[];
    var Smp_Point=[];*/
    

    var offset = 80.0;
    var canvasFullRack=document.getElementById('canvas');

    var rackWidth = canvasFullRack.offsetWidth - offset;
    var rackHeight = canvasFullRack.offsetHeight  - offset;

    m_Cxp = rackWidth;
    if (m_Cxp > (rackHeight)) m_Cxp = rackHeight;

    m_x0 = (rackWidth + offset - m_Cxp) / 2;
    m_y0 = (rackHeight + offset - m_Cxp) / 2;

    ctx.lineWidth = 2;
    ctx.strokeStyle = 'black';
    const circle1 = new Path2D();
    circle1.arc(rackWidth/2+40,rackHeight/2+40,340, 0, 2 * Math.PI);
    ctx.fillStyle = 'white';
    
    ctx.fill(circle1);
    ctx.stroke(circle1);

    ctx.lineWidth = 2;
    ctx.strokeStyle = 'black';
    const circle2 = new Path2D();
    circle2.arc(rackWidth/2+40,rackHeight/2+40,300, 0, 2 * Math.PI);
    ctx.fillStyle = 'white';
    
    ctx.fill(circle2);
    ctx.stroke(circle2);

   /* Ellipse circ1 = new Ellipse();
    circ1.StrokeThickness = 1;
    circ1.Stroke = Brushes.Black;
    circ1.Fill = Brushes.LightSlateGray;
    // Set the width and height of the Ellipse.
    circ1.Width = rackWidth;
    circ1.Height = rackHeight;
    circ1.Name = "OUTERCIRCLE1";
    canvasFullRack.Children.Add(circ1);
    Canvas.SetLeft(circ1, 40);
    Canvas.SetTop(circ1, 40);

    Ellipse circ2 = new Ellipse();
    circ2.StrokeThickness = 1;
    circ2.Stroke = Brushes.Black;
    circ2.Fill = Brushes.LightSlateGray;
    // Set the width and height of the Ellipse.
    circ2.Width = rackWidth - 55;
    circ2.Height = rackHeight - 55;
    circ2.Name = "OUTERCIRCLE2";
    canvasFullRack.Children.Add(circ2);
    Canvas.SetLeft(circ2, 67);
    Canvas.SetTop(circ2, 67);*/


    drg = (360.0 / CuvetCount * Math.PI / 180.0);
    drg1 = (2.0 * Math.PI / 180.0);
    var pointsArray=Array(4).fill(null).map(() => Array(2));
    //RCT
    for (i = 1; i <= CuvetCount; i++)
    {
        x = m_x0 + (m_Cxp / 2.0 - (m_Cxp - 24.0 * m_Scale) / 1.8 * Math.cos(drg * (i - 1) + 24 * Math.PI / 180.0 - drg1));
        y = m_y0 + (m_Cxp / 2.0 - (m_Cxp - 24.0 * m_Scale) / 1.8 * Math.sin(drg * (i - 1) + 24 * Math.PI / 180.0 - drg1));
        xb = m_x0 + (m_Cxp / 2.0 - (m_Cxp - 100.0 * m_Scale) / 1.8 * Math.cos(drg * (i - 1) + 24 * Math.PI / 180.0 - drg1));
        yb = m_y0 + (m_Cxp / 2.0 - (m_Cxp - 100.0 * m_Scale) / 1.8 * Math.sin(drg * (i - 1) + 24 * Math.PI / 180.0 - drg1));
        pointsArray[0][0]=x;
        pointsArray[0][1]=y
        pointsArray[1][0]=xb;
        pointsArray[1][1]=yb;
        x = m_x0 + (m_Cxp / 2.0 - (m_Cxp - 24.0 * m_Scale) / 1.8 * Math.cos(drg * (i - 1) + 24 * Math.PI / 180.0 + drg1));
        y = m_y0 + (m_Cxp / 2.0 - (m_Cxp - 24.0 * m_Scale) / 1.8 * Math.sin(drg * (i - 1) + 24 * Math.PI / 180.0 + drg1));
        xb = m_x0 + (m_Cxp / 2.0 - (m_Cxp - 100.0 * m_Scale) / 1.8 * Math.cos(drg * (i - 1) + 24 * Math.PI / 180.0 + drg1));
        yb = m_y0 + (m_Cxp / 2.0 - (m_Cxp - 100.0 * m_Scale) / 1.8* Math.sin(drg * (i - 1) + 24 * Math.PI / 180.0 + drg1));
        pointsArray[2][0]=xb;
        pointsArray[2][1]=yb
        pointsArray[3][0]=x;
        pointsArray[3][1]=y;
        ctx.fillPolygon(pointsArray, 'rgb(130, 130, 130)','#000',i);
    }
    var smpArray=Array(2);
    drg = (360.0 / SampleCount * Math.PI / 180.0);
    for (i = 0; i < SampleCount; i++)
    {
        x = m_x0 + m_Cxp / 2.0 + (m_Cxp - 300.0 * m_Scale) / 1.5 * Math.cos(drg * i);   //130
        y = m_y0 + m_Cxp / 2.0 + (m_Cxp - 300.0 * m_Scale) / 1.5 * Math.sin(drg * i);
        bt = (30 * m_Scale);
        smpArray[0]=x;
        smpArray[1]=y;
        ctx.fillCircle(smpArray,bt, '#F00','#000',i);
    }
   /* var regArray=Array(4).fill(null).map(() => Array(2));
    drg = (360.0 / ReagentCount * Math.PI / 180.0);
    drg1 = (3.0 * Math.PI / 180.0);
    for (i = 0; i < ReagentCount; i++)
    {
        x = m_x0 + (m_Cxp / 2.0 + (m_Cxp - 270.0 * m_Scale) / 1.8 * Math.cos(drg * i - drg1));  //180.0
        y = m_y0 + (m_Cxp / 2.0 + (m_Cxp - 270.0 * m_Scale) / 1.8 * Math.sin(drg * i - drg1));
        xb = m_x0 + (m_Cxp / 2.0 + (m_Cxp - 650.0 * m_Scale) / 1.8 * Math.cos(drg * i - drg1));  //350.0
        yb = m_y0 + (m_Cxp / 2.0 + (m_Cxp - 650.0 * m_Scale) / 1.8 * Math.sin(drg * i - drg1));
        regArray[0][0] = x;
        regArray[0][1] = y;
        regArray[1][0] = xb;
        regArray[1][1] = yb;
        x = m_x0 + (m_Cxp / 2.0 + (m_Cxp - 270.0 * m_Scale) / 1.8 * Math.cos(drg * i + drg1));
        y = m_y0 + (m_Cxp / 2.0 + (m_Cxp - 270.0 * m_Scale) / 1.8 * Math.sin(drg * i + drg1));
        xb = m_x0 + (m_Cxp / 2.0 + (m_Cxp - 650.0 * m_Scale) / 1.8 * Math.cos(drg * i + drg1));
        yb = m_y0 + (m_Cxp / 2.0 + (m_Cxp - 650.0 * m_Scale) / 1.8 * Math.sin(drg * i + drg1));
        regArray[2][0] = xb;
        regArray[2][1] = yb;
        regArray[3][0] = x;
        regArray[3][1] = y;
        ctx.fillPolygon(regArray, '#F00','#000',i);
    }*/
}
var apiStartStatus=0; 
var timer = 0;
const uri = 'https://localhost:7222/Run/';
jQuery("#btnStart").click(function ()
{
    apiStartStatus=1;
    startRun();
});

jQuery("#btnPause").click(function ()
{
    apiStartStatus=2;
    startRun();
});

jQuery("#btnStop").click(function ()
{
    apiStartStatus=0;
    startRun();
});

function startRun()
{
    jQuery.ajax({
        type: "Get",
        url: 'https://localhost:7222/Run/'+apiStartStatus,
        dataType: "jsonp",    
        crossDomain:true,
        contentType: 'application/json',
        Accept: 'application/json',
        success: function (response)
        {
            if(apiStartStatus==1)
                //loop();
            if(apiStartStatus==0)
                stop();   
        },
        error: function ()
        {
             alert("Error occured!!");
             stop(); 
        }
    });
}

function getCounter()
{
    jQuery.ajax({
        type: "Get",
        url: uri,
        dataType : 'json',   //you may use jsonp for cross origin request
        crossDomain:true,
        contentType: 'application/json',
        Accept: 'application/json',
        success: function (response)
        {
            document.getElementById("txtCounter").value = response;
            /*alert(data);*/
        },
        error: function ()
        {
             alert("Error occured!!");
             document.getElementById("txtCounter").value=0;
        }
    });
} 

var loop = function(){
    getCounter();
    timer=setTimeout(loop, 100);
}

function stop() 
{
    if (timer) {
        clearTimeout(timer);
        timer = 0;
        document.getElementById("txtCounter").value=0;
    }
}
  
</script>